from dosage.modules.helpers.BasicComicModule import BasicComicModule

class XHTMLComicModule(BasicComicModule):
    '''Base class with functions for "l33t" (XHTML with approriate <link>
    elements) comic modules.

    Classes should define the following attributes / properties:
        latestUrl 
        stripUrl
        imageRegex
    '''
    latestUrl = ''
    stripUrl = ''
    imageRegex = None

    def __init__(self):
        BasicComicModule.__init__(self)
        self.currentUrl = None
    
    def getNextComic(self):
        comicUrl, prevUrl = parseXHTMLComic(self.currentUrl, self.imageRegex)
        c = self.getComic(comicUrl, self.currentUrl)
        self.currentUrl = prevUrl
        return c
    
    def setStrip(self, index):
        self.currentUrl = self.imageUrl % index
	return self.getNextComic()

class ComicContentHandler(xml.sax.handler.ContentHandler):
    def __init__(self, imageRegex):
        xml.sax.handler.ContentHandler.__init__(self)
        self.imageRegex = imageRegex

    def startDocument(self):
        self.comicUrl = None
        self.prevUrl = None

    def startElement(self, name, attrs):
        if name == 'link' and attrs['rel'] == 'prev':
            self.prevUrl = attrs['href']
        elif name == 'img':
            url = attrs.get('src', '')
            m = self.imageRegex.match(url)
            if m:
                self.comicUrl = url

def parseXHTMLComic(url, imageRegex):
    urlobj = urlopen(url)
    handler = ComicContentHandler(imageRegex)
    xml.sax.parse(urlobj, handler)
    if not handler.comicUrl:
        raise NoMatchError, 'Unable to match comic URL in: %s' % url

    comicUrl = urllib.basejoin(url, handler.comicUrl)
    prevUrl = handler.prevUrl and urllib.basejoin(url, handler.prevUrl)
    return comicUrl, prevUrl
